<template>
  <v-app :style="{ background: themeBackground }">
    <v-row class="login-wrapper">
      <v-col cols="12" sm="6">
        <v-img alt="Logo Airvam" contain width="50%" src="/airvam.svg">
        </v-img>
      </v-col>
      <v-col cols="12" sm="6">
        <v-spacer></v-spacer>
        <div class="d-flex align-center justify-space-between">
          <v-img width="110px" contain alt="Logo Ministère des Armées" src="/logo_ministere_armees.svg">
          </v-img>
          <a target="_blank" rel="noopener" href="https://beta.gouv.fr/startups/?incubateur=fabnumdef">
            <v-img width="150" contain alt="Logo Fabrique Numérique" src="/fabnum.svg">
            </v-img>
          </a>
          <div v-if="$config.public.appEnv === 'dev'">
            Version {{ appVersion }}
          </div>
        </div>
      </v-col>
    </v-row>
  </v-app>
</template>

<script setup lang="ts">

import { version } from "../../package.json";

useHead({
  meta: [
    {
      hid: 'robots',
      name: 'robots',
      content: 'noindex, nofollow'
    }
  ]
})

definePageMeta({
  auth: {
    unauthenticatedOnly: true,
    navigateAuthenticatedTo: '/',
  }
})

const appVersion = ref(version);
const { $vuetify, $toast, $config } = useNuxtApp();
const { setToken } = useAuthState();
const code = useRoute().query.code;
const sessionState = useRoute().query.session_state;

// TODO: put this logic into a composable
const themeBackground = computed(() => {
  const theme = $vuetify.theme.current.value.dark ? 'dark' : 'light';
  return $vuetify.theme.themes.value?.[theme].colors.background;
})

onMounted(async () => {
  try {
    const res = await $fetch<{ token: string }>(
      `/auth/login/token?code=${code}&session_state=${sessionState}`
    )

    await setToken(res.token);
    navigateTo('/');
  } catch (e: any) {
    console.error(e.toJSON());
    if (e.response?.data?.message) {
      $toast.error(e.response?.data?.message);
    }
    navigateTo('/login');
  }
})
</script>

<style lang="scss">
@import "../../assets/variables.scss";

.login-wrapper {
  height: 100vh;
  margin: 0;

  .v-col-12 {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    height: 100%;

    &:first-child {
      background-color: $color-primary;
    }

    &:last-child {
      align-items: start;
      padding-left: 5%;
    }
  }
}
</style>
